VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MsComCtl.ocx"
Begin VB.UserControl ComboDrive 
   ClientHeight    =   675
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4080
   ScaleHeight     =   675
   ScaleWidth      =   4080
   ToolboxBitmap   =   "ComboDrive.ctx":0000
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   240
      Left            =   4920
      ScaleHeight     =   240
      ScaleWidth      =   240
      TabIndex        =   0
      Top             =   480
      Visible         =   0   'False
      Width           =   240
   End
   Begin MSComctlLib.ImageCombo ImageCombo 
      Height          =   330
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   582
      _Version        =   393216
      ForeColor       =   -2147483640
      BackColor       =   16777215
      Enabled         =   0   'False
   End
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   5880
      Top             =   240
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   12648384
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16777215
      _Version        =   393216
   End
End
Attribute VB_Name = "ComboDrive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'*****************************
'Declaraciones Api
'*****************************

'Recupera los Drives
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" _
                            (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

'Recupera informacin de los archivos
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias _
                        "SHGetFileInfoA" (ByVal pszPath As String, _
                        ByVal dwFileAttributes As Long, psfi As SHFILEINFO, _
                        ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long

'Dibuja en el Picture1 el cono que luego se cargar en el control ImageList
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, _
                        ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, _
                        ByVal y As Long, ByVal fStyle As Long) As Long

'Dibuja un icono en un HDC, en este caso en un PictureBox, para el icono de es _
critorio, documetos recientes etc...
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As _
                        Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth _
                        As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, _
                        ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long

'Destruye el handle del icono obtenido antes con DrawIconEx
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

'Extrae archivos de iconos
Private Declare Function ExtractAssociatedIcon Lib "shell32.dll" Alias _
                        "ExtractAssociatedIconA" (ByVal hInst As Long, ByVal _
                        lpIconPath As String, lpiIcon As Long) As Long


'recupera un puntero a la UdtITEMIDLIST de una carpeta especial.
Private Declare Function apiSHGetSpecialFolderLocation Lib "shell32" _
    Alias "SHGetSpecialFolderLocation" _
    (ByVal hwndOwner As Long, _
    ByVal nFolder As Long, _
    ppidl As Long) _
    As Long
    
    
' convierte un item de identificador de lista de un archivo en su path
Private Declare Function apiSHGetPathFromIDList Lib "shell32" _
    Alias "SHGetPathFromIDList" _
    (pidl As Long, _
    ByVal pszPath As String) _
    As Long
    
'Libera bloques de memoria usados
Private Declare Sub sapiCoTaskMemFree Lib "ole32" _
    Alias "CoTaskMemFree" _
    (ByVal pv As Long)


'***********************
'Constantes para las Api
'***********************
Private Const DI_MASK = &H1
Private Const DI_IMAGE = &H2
Private Const DI_NORMAL = DI_MASK Or DI_IMAGE

'Para las carpetas especiales, escritorio, Mis documentos etc..
Private Const CSIDL_RECENT = &H8
Private Const CSIDL_DESKTOPDIRECTORY = &H10
Private Const CSIDL_PERSONAL = &H5
Private Const CSIDL_COMMON_DOCUMENTS = &H2E

'Para los iconos usdos con el Api Image_ListDraw

Private Const SHGFI_DISPLAYNAME = &H200
Private Const SHGFI_TYPENAME = &H400
Private Const SHGFI_LARGEICON = &H0
Private Const SHGFI_SMALLICON = &H1
Private Const SHGFI_SYSICONINDEX = &H4000
Private Const ILD_TRANSPARENT = &H1
Private Const MAX_PATH = 260


Private Const Drives = SHGFI_SYSICONINDEX Or SHGFI_SMALLICON Or SHGFI_DISPLAYNAME
Private Const Iconos = SHGFI_SYSICONINDEX Or SHGFI_SMALLICON Or SHGFI_DISPLAYNAME Or _
                                                                SHGFI_TYPENAME


'****************************
'Estructuras
'****************************

'Estructura necesaria para el Api SHGetFileInfo
Private Type SHFILEINFO
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * MAX_PATH
    szTypeName As String * 80
End Type

Enum E_Estilo
  [Solo Drives] = 0
  [Normal] = 1
End Enum


'*********************************
'Variables
'*********************************

'Variable para usar SHFILEINFO
Dim FI As SHFILEINFO
'Handle de imagen para usar con el Api Image_ListDraw
Dim hImage As Long

'Valores de propiedades por default:
Const m_def_Path = ""
Const m_def_hWnd = 0
Private m_def_Estilo As E_Estilo

'Copia de las variables locales:
Dim m_Path As String
Dim m_hWnd As Long
Private m_Text As String
Private m_Estilo As Long
Private m_ListIndex As Integer

'****************************
'Declaraciones de eventos:
'****************************

Event Change() 'MappingInfo=ImageCombo1,ImageCombo,-1,Change
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=ImageCombo1, _
                                                    ImageCombo , -1, KeyDown
Event KeyPress(KeyAscii As Integer) 'MappingInfo=ImageCombo1,ImageCombo,-1,KeyPress
Event KeyUp(KeyCode As Integer, Shift As Integer) _
                                       'MappingInfo=ImageCombo1,ImageCombo,-1,KeyUp
Event Validate(Cancel As Boolean) 'MappingInfo=ImageCombo1,ImageCombo,-1,Validate




'*********************
'Mtodos y funciones
'*********************+

Public Sub Refresh()

Dim strSave As String * 80, i As Integer


ImageList1.BackColor = ImageCombo.BackColor
ImageCombo.ComboItems.Clear

If m_Estilo Then

'Recientes
'************
Extraer fGetSpecialFolderLocation(CSIDL_RECENT), Iconos, ILD_TRANSPARENT, 0

'Escritorio
'************
ExtraerOtros "Escritorio", 2, 1, fGetSpecialFolderLocation(CSIDL_DESKTOPDIRECTORY), 2, 3


'Mis documentos
'**************
Extraer fGetSpecialFolderLocation(CSIDL_PERSONAL), Iconos, ILD_TRANSPARENT, 1


'Extraer icono Mi Pc
'*******************+
ExtraerOtros "Mi PC", 4, 1, "Mi PC", 4, 0

End If


'Drives
'*************

GetLogicalDriveStrings 80, strSave


For i = 1 To 20
    If StripTerminator(strSave) = "" Then Exit For
       Extraer StripTerminator(strSave), Drives, SHGFI_LARGEICON, 3
       strSave = Right$(strSave, Len(strSave) - InStr(1, strSave, Chr$(0)))
Next i

If m_Estilo Then

'Mis documentos todoso los Users
'*********************************
 Extraer fGetSpecialFolderLocation(CSIDL_COMMON_DOCUMENTS), Iconos, ILD_TRANSPARENT, 2

'Elementos de escritorio
'**************************
ListarCombo fGetSpecialFolderLocation(CSIDL_DESKTOPDIRECTORY)

End If

'Seleccionamos el escritorio en el imageCombo
ImageCombo.SelectedItem = ImageCombo.ComboItems(m_ListIndex)
If m_Path = "" Then m_Path = ImageCombo.SelectedItem.Tag

End Sub

'Extrae los iconos del archivo explorer.exe para el escritorio y Mi PC
'********************************************************************
Private Sub ExtraerOtros(cCaption As String, pos As Integer, indent As Integer, _
                        tTag As String, indice As Integer, iIcono As Long)
Dim mIcon As Long

Picture1.Cls
With ImageCombo
     
     mIcon = ExtractAssociatedIcon(App.hInstance, Environ$("windir") _
                                   & "\explorer.exe", iIcono)
     
     DrawIconEx Picture1.hdc, 0, 0, mIcon, 16, 16, 0, 0, DI_NORMAL
     DestroyIcon mIcon
     
     ImageList1.ListImages.Add , Picture:=Picture1.Image
     .ComboItems.Add , , cCaption, pos, pos, indent
     .ComboItems(indice).Tag = tTag
End With



End Sub

'Extrae los Drives
'*****************
Private Sub Extraer(Ruta As String, flag As Long, Estilo As Long, Identation As Integer)

Picture1.Cls

hImage = SHGetFileInfo(Ruta, ByVal 0&, FI, Len(FI), flag)

ImageList_Draw hImage, FI.iIcon, Picture1.hdc, 0, 0, Estilo
ImageList1.ListImages.Add , Picture:=Picture1.Image
If ImageCombo.ImageList Is Nothing Then Set ImageCombo.ImageList = ImageList1
ImageCombo.ComboItems.Add , , StripTerminator(FI.szDisplayName), _
                             ImageList1.ListImages.Count, ImageList1.ListImages.Count, _
                             Identation

ImageCombo.ComboItems(ImageCombo.ComboItems.Count).Tag = Ruta
End Sub


'Lista los elementos del esxritorio
'************************************
Private Sub ListarCombo(Ruta As String)

Dim Directorios As String

If Not Right(Ruta, 1) = "\" Then Ruta = Ruta & "\"
Directorios = Dir(Ruta, vbDirectory)
Do While Directorios <> ""

If Directorios <> "." And Directorios <> ".." Then
  If (GetAttr(Ruta & Directorios) And vbDirectory) = vbDirectory Then
     Extraer Ruta & Directorios, Iconos, ILD_TRANSPARENT, 1
  End If
End If

Directorios = Dir
Loop

End Sub

'Recupera el path y descripcin de las Carpetas especiales de windows
'**********************************************************************
Private Function fGetSpecialFolderLocation(ByVal lngCSIDL As Long) As String

Dim lngRet As Long
Dim strLocation As String
Dim pidl As Long

    '   retrieve a PIDL for the specified location
    lngRet = apiSHGetSpecialFolderLocation(UserControl.hWnd, lngCSIDL, pidl)
    If lngRet = 0 Then
        strLocation = Space$(MAX_PATH)
        '  convert the pidl to a physical path
        lngRet = apiSHGetPathFromIDList(ByVal pidl, strLocation)
        If Not lngRet = 0 Then
            '   if successful, return the location
            fGetSpecialFolderLocation = Left$(strLocation, _
                                InStr(strLocation, vbNullChar) - 1)
        End If

        Call sapiCoTaskMemFree(pidl)
    End If
End Function

'Funcin que elimina los espacios nulos
'****************************************

Private Function StripTerminator(sInput As String) As String
    Dim ZeroPos As Integer
    ZeroPos = InStr(1, sInput, vbNullChar)
    If ZeroPos > 0 Then
        StripTerminator = Left$(sInput, ZeroPos - 1)
    Else
        StripTerminator = sInput
    End If
    
End Function



'**********************************
'Propiedades
'**********************************

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MappingInfo=ImageCombo1,ImageCombo,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Devuelve o establece el color de fondo de un objeto."
    BackColor = ImageCombo.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    ImageCombo.BackColor() = New_BackColor
    If Ambient.UserMode Then
       Refresh
    End If
    PropertyChanged "BackColor"
End Property

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MappingInfo=ImageCombo1,ImageCombo,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Devuelve un objeto Font."
Attribute Font.VB_UserMemId = -512
    Set Font = ImageCombo.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set ImageCombo.Font = New_Font
    PropertyChanged "Font"
End Property

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MappingInfo=ImageCombo1,ImageCombo,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Devuelve o establece el color de fondo usado para mostrar textos y grficos en un objeto."
    ForeColor = ImageCombo.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    ImageCombo.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MappingInfo=ImageCombo1,ImageCombo,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Devuelve o establece el texto mostrado cuando el mouse se sita sobre un control."
    ToolTipText = ImageCombo.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    ImageCombo.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MemberInfo=8,0,0,0
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Devuelve un controlador (de Microsoft Windows) a la ventana de un objeto."
Attribute hWnd.VB_MemberFlags = "400"
    hWnd = ImageCombo.hWnd
End Property

Public Property Let hWnd(ByVal New_hWnd As Long)
    MsgBox "La propiedad es de solo lectura", vbInformation, "Error"
    
End Property

'ADVERTENCIA: NO QUITAR NI MODIFICAR LAS SIGUIENTES LINEAS CON COMENTARIOS
'MemberInfo=13,0,0,0
Public Property Get Path() As String
Attribute Path.VB_MemberFlags = "600"
    Path = m_Path
End Property

Public Property Let Path(ByVal New_Path As String)
MsgBox "La propiedad es de solo lectura. Utilizar ListIndex para cambiar la unidad", _
                                                                 vbExclamation, "Error"
End Property

Public Property Get Estilo() As E_Estilo
Estilo = m_Estilo
End Property

Public Property Let Estilo(ByVal vNewValue As E_Estilo)

If Ambient.UserMode = False Then
   m_Estilo = vNewValue
   'Refresh
   PropertyChanged "Estilo"
   m_ListIndex = 2
Else
   MsgBox "La propiedad es de solo lectura", vbCritical, "Error"
End If



End Property

Public Property Get ListIndex() As Integer
ListIndex = m_ListIndex
End Property

Public Property Let ListIndex(Value As Integer)
m_ListIndex = Value

If Ambient.UserMode Then
   ImageCombo.SelectedItem = ImageCombo.ComboItems(Value)
   m_Path = ImageCombo.ComboItems(Value).Tag
   RaiseEvent Change
End If
PropertyChanged "ListIndex"
End Property

Private Sub ImageCombo_Dropdown()
'Antes de refrescar guardamos el ndice seleccionado
m_ListIndex = ImageCombo.SelectedItem.Index
'refrescamos el ImageCombo cargando todo nuevamente
Refresh
End Sub

'*********************
'Eventos del imagecombo
'*********************

Private Sub ImageCombo_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub ImageCombo_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub ImageCombo_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub ImageCombo_Validate(Cancel As Boolean)
RaiseEvent Validate(Cancel)
End Sub

Private Sub ImageCombo_Click()
Dim pos As Integer
With ImageCombo.SelectedItem
     If InStr(Len(.Tag), .Tag, "\") Then
        m_Path = Left(.Tag, Len(.Tag) - 1)
     Else
        m_Path = .Tag
     End If
End With
m_ListIndex = ImageCombo.SelectedItem.Index
RaiseEvent Change
End Sub




'***************************************************
'Inicializacin, escritura y lectura de propiedades
'***************************************************


'Inicializar propiedades para control de usuario
Private Sub UserControl_InitProperties()
    m_hWnd = ImageCombo.hWnd
    m_Estilo = 1
    ImageCombo.Text = Extender.Name
    m_Path = m_def_Path
    m_ListIndex = 2
End Sub



'Cargar valores de propiedad desde el almacn
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    ImageCombo.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    Set ImageCombo.Font = PropBag.ReadProperty("Font", Ambient.Font)
    ImageCombo.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    ImageCombo.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    m_hWnd = PropBag.ReadProperty("hWnd", m_def_hWnd)
    m_Path = PropBag.ReadProperty("Path", m_def_Path)
    ImageCombo.Text = Extender.Name
    m_Estilo = PropBag.ReadProperty("Estilo", m_def_Estilo)
    m_ListIndex = PropBag.ReadProperty("ListIndex", 1)
End Sub

'Escribir valores de propiedad en el almacn
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", ImageCombo.BackColor, &H80000005)
    Call PropBag.WriteProperty("Font", ImageCombo.Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColor", ImageCombo.ForeColor, &H80000008)
    Call PropBag.WriteProperty("ToolTipText", ImageCombo.ToolTipText, "")
    Call PropBag.WriteProperty("hWnd", m_hWnd, m_def_hWnd)
    Call PropBag.WriteProperty("Path", m_Path, m_def_Path)
    Call PropBag.WriteProperty("Estilo", m_Estilo, m_def_Estilo)
    Call PropBag.WriteProperty("ListIndex", m_ListIndex, 1)
    
End Sub


'**************************
'Eventos del UserControl
'**************************

Private Sub UserControl_Resize()
    Height = ImageCombo.Height
     ImageCombo.Width = Width
    ImageCombo.Move 0, 0
End Sub

Private Sub UserControl_Show()
If Ambient.UserMode Then
   ImageCombo.Enabled = True
   'cargamos el imagecombo
   Refresh
End If
End Sub
